unit monitor;
{$R monitor.dcr}
interface

uses
  Messages, SysUtils,Graphics, Controls, Forms
  ,classes,stdctrls,extctrls;

type
  Tmonitor = class(Tcustompanel)
  private
    { Private declarations }
    fmemo:tmemo;
    esquina1,esquina2,esquina3,esquina4,lateral1,lateral2,lateral3,lateral4:tbitmap;
    fcolorglass,fcolorletra:tcolor;
    freadonly,fmonitor_on:boolean;
    fmaxlength:integer;
    onoff:tnotifyevent;
    procedure setcolorglass(colorgl:tcolor);

     {Eventos}
    procedure setmonitor_on(variable:boolean);
    procedure setondblclick(raton:tnotifyevent);
    function getondblclick:tnotifyevent;
    procedure setonclick(raton:tnotifyevent);
    function getonclick:tnotifyevent;
    procedure setonchange(chang:tnotifyevent);
    function getonchange:tnotifyevent;
    procedure setonexit(chang:tnotifyevent);
    function getonexit:tnotifyevent;
    procedure setonenter(chang:tnotifyevent);
    function getonenter:tnotifyevent;
    procedure setonmousemove(raton:TMouseMoveEvent);
    function getonmousemove:TMouseMoveEvent;
    procedure setonmouseup(raton:TMouseEvent);
    function getonmouseup:TMouseEvent;
    procedure setonmousedown(raton:TMouseEvent);
    function getonmousedown:TMouseEvent;
    procedure setonkeypressed(raton:TKeyPressEvent);
    function getonkeypressed:TKeyPressEvent;
       {Propiedades del texto}
    procedure settext(t:string);
    function gettext:string;
    procedure setfont(sfont:tfont);
    function getfont:tfont;
    procedure setreadonly(re:boolean);
    procedure setmaxlength(s:integer);
    procedure setlines(s:tstrings);
    function getlines :tstrings;

  protected
    { Protected declarations }
    procedure WMSize(var Message: TWMSize); message WM_SIZE;
    procedure Paint; override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);override;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property text:string read gettext write settext;
    procedure clear;
    procedure copytoclipboard;
    procedure cuttoclipboard;
    procedure pastefromclipboard;
    procedure selectall;

  published
    { Published declarations }
    property Colorglass:Tcolor read fcolorglass write setcolorglass;
    property monitor_on:boolean read fmonitor_on write setmonitor_on;
          {Eventos}
    property onclick:Tnotifyevent read getonclick write setonclick;
    property ondblclick:Tnotifyevent read getondblclick write setondblclick;
    property onchange:Tnotifyevent read getonchange write setonchange;
    property onenter:Tnotifyevent read getonenter write setonenter;
    property onexit:Tnotifyevent read getonexit write setonexit;
    property onKeypress:tkeypressevent read getonkeypressed write setonkeypressed;
    property onmouseup:TMouseEvent read getonmouseup write setonmouseup;
    property onmousedown:TMouseEvent read getonmousedown write setonmousedown;
    property onmousemove:TMouseMoveEvent read getonmousemove write setonmousemove;
    property onon_off:tnotifyevent read onoff write onoff;
          {propiedades del texto}
    property Font : tfont read getfont write setfont;
    property readonly : boolean read freadonly write setreadonly;
    property maxlength: integer read fmaxlength write setmaxlength;
    property lines : tstrings read getlines write setlines;
  end;
Tmemo_monitor = class(Tmemo)
protected
procedure KeyPress(var Key: Char); override;
end;


procedure Register;

implementation
{$R monitor.res}
var monitoron:boolean;

procedure tmemo_monitor.KeyPress(var Key: Char);
begin
if monitoron=false then key:=#0;

inherited keypress (key);

end;



constructor Tmonitor.Create(AOwner: TComponent);

begin
  inherited Create(AOwner);

  { Valores por defecto de esta carpeta }
  monitoron:=true;
  Width  := 220;
  Height := 220;
  fcolorglass:=clwhite;
  freadonly:=false;
  parentcolor:=true;
  fmaxlength:=0;
  { Creo el tmemo }
  Fmemo := Tmemo_monitor.Create(Self);
  InsertControl(Fmemo);
  fmemo.borderstyle:=bsnone;
     {bitmap esquina1}
  esquina1:=tbitmap.create;
  esquina1.loadfromresourcename(HInstance,'esquina1');
     {bitmap esquina abajo-derecha}
  esquina2:=tbitmap.create;
  esquina2.loadfromresourcename(HInstance,'esquina2');
       {bitmap esquina abajo-izquierda}
  esquina3:=tbitmap.create;
  esquina3.loadfromresourcename(HInstance,'esquina3');
       {bitmap esquina arriba-derecha}
  esquina4:=tbitmap.create;
  esquina4.loadfromresourcename(HInstance,'esquina4');
      {bitmap lateral derecho}
  lateral1:=tbitmap.create;
  lateral1.loadfromresourcename(HInstance,'lateral1');
      {bitmap lateral abajo}
  lateral2:=tbitmap.create;
  lateral2.loadfromresourcename(HInstance,'lateral2');
   {bitmap lateral izquierda}
  lateral3:=tbitmap.create;
  lateral3.loadfromresourcename(HInstance,'lateral3');
   {bitmap lateral arriba}
  lateral4:=tbitmap.create;
  lateral4.loadfromresourcename(HInstance,'lateral4');

  fmemo.top:=24;
  fmemo.left:=31;
  fmemo.height:=height-67;
  fmemo.width:=width-64;
  fmonitor_on:=true;
  fcolorletra:=clblack;
end;
destructor Tmonitor.Destroy;
begin
  { Libero la memoria ocupada por el tmemo }
  Fmemo.free;
  esquina1.free;
  esquina2.free;
  esquina3.free;
  esquina4.free;
  lateral1.free;
  lateral2.free;
  lateral3.free;
  lateral4.free;
  inherited Destroy;
end;
procedure tmonitor.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
        begin
        if (x>(width-35)) then if (x<(width-14)) then if (y>(height-26)) then
        if (y<(height-14)) then
          begin
          if assigned(onoff) then onoff(self);
          fmonitor_on:=not fmonitor_on;
          monitoron:=not monitoron;
          setmonitor_on(fmonitor_on);
          end;
        end;

procedure tmonitor.setmonitor_on(variable:boolean);
        begin
        fmonitor_on:=variable;
        monitoron:=variable;
        if fmonitor_on=true then
             begin
             fmemo.Color:=fcolorglass;
             fmemo.Font.color:=fcolorletra;
             end;
        if fmonitor_on=false then
             begin
             fmemo.Color:=clblack+$00404040;
             fcolorletra:=fmemo.Font.color;
             fmemo.Font.color:=fmemo.color;
             end;
        if fmonitor_on then canvas.brush.Color:=cllime else canvas.brush.color:=clblack;
        canvas.floodfill(width-13,height-16,canvas.pixels[width-13,height-16],fssurface);
        end;
procedure tmonitor.clear;
        begin
        fmemo.clear;
        end;
procedure tmonitor.copytoclipboard;
        begin
        fmemo.copytoclipboard;
        end;
procedure tmonitor.cuttoclipboard;
        begin
        fmemo.cuttoclipboard;
        end;
procedure tmonitor.pastefromclipboard;
        begin
        fmemo.pastefromclipboard;
        end;
procedure tmonitor.selectall;
        begin
        fmemo.selectall;
        end;
procedure tmonitor.setlines(s:tstrings);
        begin
        fmemo.lines:=s;
        end;
function tmonitor.getlines:tstrings;
        begin
        result:=fmemo.lines;
        end;


procedure tmonitor.setmaxlength(s:integer);
        begin
        fmemo.MaxLength:=s;
        fmaxlength:=s;
        end;
procedure tmonitor.setreadonly(re:boolean);
        begin
        fmemo.ReadOnly:=re;
        freadonly:=re;
        end;
procedure tmonitor.setfont(sfont:tfont);
        begin
        fmemo.font:=sfont;
        end;
function tmonitor.getfont:tfont;
        begin
        result:=fmemo.Font;
        end;
procedure tmonitor.settext(t:string);
        begin
        fmemo.text:=t;
        end;
function tmonitor.gettext:string;
        begin
        result:=fmemo.text;
        end;
procedure tmonitor.setcolorglass(colorgl:tcolor);
        begin
        fcolorglass:=colorgl;
        invalidate;
        end;

function tmonitor.getonclick:tnotifyevent;
        begin
        result:=fmemo.onclick;
        end;
procedure tmonitor.setonclick(raton:tnotifyevent);
        begin
        fmemo.onclick:=raton;
        end;
function tmonitor.getondblclick:tnotifyevent;
        begin
        result:=fmemo.ondblclick;
        end;
procedure tmonitor.setondblclick(raton:tnotifyevent);
        begin
        fmemo.ondblclick:=raton;
        end;

function tmonitor.getonkeypressed:tkeypressevent;
        begin
        result:=fmemo.onkeypress;
        end;
procedure tmonitor.setonkeypressed(raton:tkeypressevent);
        begin
        fmemo.onkeypress:=raton;
        end;

function tmonitor.getonchange:tnotifyevent;
        begin
        result:=fmemo.onchange;
        end;
procedure tmonitor.setonchange(chang:tnotifyevent);
        begin
        fmemo.onchange:=chang;
        end;
function tmonitor.getonenter:tnotifyevent;
        begin
        result:=fmemo.onenter;
        end;
procedure tmonitor.setonenter(chang:tnotifyevent);
        begin
        fmemo.onenter:=chang;
        end;
function tmonitor.getonexit:tnotifyevent;
        begin
        result:=fmemo.onexit;
        end;
procedure tmonitor.setonexit(chang:tnotifyevent);
        begin
        fmemo.onexit:=chang;
        end;



function tmonitor.getonmousemove:TMouseMoveEvent;
        begin
        result:=fmemo.OnMouseMove;
        end;
procedure tmonitor.setonmousemove(raton:tmousemoveevent);
        begin
        fmemo.onmousemove:=raton;
        end;
function tmonitor.getonmouseup:TMouseEvent;
        begin
        result:=fmemo.OnMouseup;
        end;
procedure tmonitor.setonmouseup(raton:tmouseevent);
        begin
        fmemo.onmouseup:=raton;
        end;
function tmonitor.getonmousedown:TMouseEvent;
        begin
        result:=fmemo.OnMousedown;
        end;
procedure tmonitor.setonmousedown(raton:tmouseevent);
        begin
        fmemo.onmousedown:=raton;
        end;


procedure tmonitor.WMSize(var Message: TWMSize);
begin
  with Message do begin
    if Width < 115 then Self.Width := 115;
    if Height < 105 then Self.Height := 105;
    fmemo.top:=24;
    fmemo.left:=31;
    fmemo.height:=height-67;
    fmemo.width:=width-64;
    { Repinto... }
    Invalidate;
  end;
end;
procedure tmonitor.Paint;
  var numbitmaps,n,n1:integer;

begin


  with Canvas do
   begin
               {dibujo los graficos de la libreta}
   numbitmaps:=height div 31;
   for n:= 0 to (numbitmaps-1) do draw(0,(31*n),lateral3);

   numbitmaps:= height div 33 ;
   for n:= 0 to (numbitmaps-1) do draw(width-33,(33*n),lateral1);

   numbitmaps:= width div 43 ;
   for n:= 0 to (numbitmaps-1) do draw((43*n),height-43,lateral2);

   numbitmaps:= width div 24 ;
   for n:= 0 to (numbitmaps-1) do draw((24*n),0,lateral4);

   draw (0,height-43,esquina3);
   draw (width-33,0,esquina1);
   draw (width-41,height-43,esquina2);
   draw (0,0,esquina4);
   if fmonitor_on then brush.Color:=cllime else brush.color:=clblack;
   floodfill(width-13,height-16,pixels[width-13,height-16],fssurface);
   end;
end;

procedure Register;
begin
  RegisterComponents('Samples', [Tmonitor]);
end;

end.
